package kr.co.icontrols.ilp300_700.imap;

import android.content.Context;
import android.util.Log;

import kr.co.icontrols.ilp300_700.ethernet.EthernetCtrl;
import kr.co.icontrols.ilp300_700.ethernet.SendNWaitMSG;
import kr.co.icontrols.ilp300_700.ethernet.iMAPCommon.iMAPResult;
import kr.co.icontrols.ilp300_700.global.Configure.ConfigValue;
import kr.co.icontrols.ilp300_700.global.Configure.SetValue;
import kr.co.icontrols.ilp300_700.global.Declare.DeviceType;

public class Request_check_lobby_passwd extends SendNWaitMSG {

    String TAG = "Request_check_lobby_passwd";

    boolean bLOG = true;   // true, false
    boolean bLOG_DEBUG = false;   // true, false
    boolean bLOG_INFO = true;   // true, false
    Context mContext;
    iMAPResult miMAPResult;
    iMAPResultCtrl miMAPResultCtrl;
    int nNonEncryptedTargetPort = 10000;
    int nEncryptedTargetPort = 11000;
    int nTargetPort = nNonEncryptedTargetPort;
    public Request_check_lobby_passwd(Context context) {
        LOG_INFO("[Request_check_lobby_passwd] === START ===");
        mContext = context;
        //setDefaultServerInfo(ConfigValue.strMainServerIPAddress,ConfigValue.nMainServerPortNum);
        setDefaultServerInfo(ConfigValue.strMainServerIPAddress,10000);
        //if (ConfigValue.eMainServerType == SetValue.Server2dot0_Integrated)
        //    nTargetPort = nEncryptedTargetPort;
    }

    private void LOG(String log) {
        if (bLOG) Log.v(TAG, log);
    }

    private void LOG_DEBUG(String log) {
        if (bLOG_DEBUG) Log.d(TAG, log);
    }

    private void LOG_INFO(String log) {
        if (bLOG_INFO) Log.i(TAG, log);
    }

    public boolean send_check_lobby_passwd_request(String strDong, String strHo, String strPW, boolean bRentHouse) {
        try {
            LOG_INFO("[send_check_lobby_passwd_request] strDong [" + strDong + "], strHo [" + strHo + "], strPW [" + strPW + "], bRentHouse [" + bRentHouse + "]");
            String strTargetIP = "";
            if (bRentHouse)
                strTargetIP = EthernetCtrl.makeIPAddress(DeviceType.RENTRESIDENCE, strDong, strHo);
            else strTargetIP = EthernetCtrl.makeIPAddress(DeviceType.RESIDENCE, strDong, strHo);
            return sendNwaitMSG(strTargetIP, 10000, MakeiMAPMSG.makeRequest_check_lobby_passwd(strPW));
        } catch (Exception e) {
            Log.e(TAG, "[Exception] send_check_lobby_passwd_request(strDong, strHo, strPW)");
            e.printStackTrace();
            return false;
        }
    }

    @Override
    protected void onProcessDoing() {
        LOG_INFO("[onProcessDoing] ===== START =====");
    }

    @Override
    protected void onProcessDone(iMAPResult eResult) {
        try {
            LOG_INFO("[onProcessDone] eResult = " + eResult);
            if (eResult == iMAPResult.RcvDone) {
                if (DocMsg != null) {
                    setItem("service");
                    String strResult = getAttributeValue(0, "result");
                    if (strResult != null) {
                        if (strResult.equalsIgnoreCase("ok")) {
                            if ((getAttributeValue(0, "name").equalsIgnoreCase("check_lobby_passwd")) && (getAttributeValue(0, "type").equalsIgnoreCase("reply"))) {
                                miMAPResultCtrl.onResult(iMAPResult.OK);
                                return;
                            } else {
                                miMAPResultCtrl.onResult(iMAPResult.ReplyIsNotMatchWithRequest);
                                return;
                            }
                        } else if (strResult.equalsIgnoreCase("fail")) {
                            miMAPResultCtrl.onResult(iMAPResult.ResultFail);
                            return;
                        } else {
                            miMAPResultCtrl.onResult(iMAPResult.UnexpectedReply);
                            return;
                        }
                    } else {
                        miMAPResultCtrl.onResult(iMAPResult.ReplyHasFault);
                        return;
                    }
                } else {
                    miMAPResultCtrl.onResult(iMAPResult.ReplyHasNoContents);
                    return;
                }
            } else {
                miMAPResultCtrl.onResult(eResult);
                return;
            }
        } catch (Exception e) {
            Log.e(TAG, "[Exception] onProcessDone(eResult)");
            e.printStackTrace();
        }
    }


    public void setResultCtrl(iMAPResultCtrl eResult) {
        try {
            miMAPResultCtrl = eResult;
        } catch (Exception e) {
            Log.e(TAG, "[Exception] setResultCtrl(Result)");
            e.printStackTrace();
        }
    }

}